import java.awt.*;
import java.util.*;

import com.umlet.constants.Constants;

@SuppressWarnings("serial")
public class CustomElementImpl extends com.umlet.custom.CustomElement {

	public CustomElementImpl()
	{
		
	}
	
	@Override
	public void paint() {
		Vector<String> textlines = Constants.decomposeStrings(this.getState());
	
		/****CUSTOM_CODE START****/
		int y = 0;
     g2.drawRoundRect(0, 0, width, height, 20,	20);
		
		// changes of the Default.java by Marianne Busch:

		// the first line indicates the UWE stereotype
		String firstLine = null;
		if (textlines.size()>0){
			firstLine = textlines.get(0);
		}
		if (firstLine != null) {
			firstLine = firstLine.trim();
			final String uweconst = "uwetype=";
			if (firstLine.toLowerCase().startsWith(uweconst)) {

				// Stereotype name and path
				
				
				final String pres = "presentation";
				final String nav = "navigation";
			 final String proc = "process";
				
				HashMap<String, String> types = new HashMap<String, String>();

				types.put("externalNode", nav);
				types.put("guidedTour", nav);
				types.put("index", nav);
				types.put("menu", nav);
				types.put("navigationClass", nav);
				types.put("query", nav);

				types.put("anchor", pres);
				types.put("anchoredCollection", pres);
				types.put("button", pres);
				types.put("customComponent", pres);
				types.put("fileUpload", pres);
				types.put("image", pres);
				types.put("inputForm", pres);
				types.put("iteratedPresentationGroup", pres);
				types.put("mediaObject", pres);
				types.put("presentationAlternatives", pres);
				types.put("presentationGroup", pres);
				types.put("presentationPage", pres);
				types.put("selection", pres);
				types.put("text", pres);
				types.put("textInput", pres);

				types.put("processClass", proc);
				types.put("systemAction", proc);
				types.put("userAction", proc);

				firstLine = firstLine.substring(uweconst.length()).trim();
				if (types.get(firstLine) != null) {
					String uweStereotypeName = firstLine;
					String uweSubfolder = types.get(firstLine);
					textlines.remove(0);

					// "<>" shows the name of the stereotype in Line 1
					String secondLine = null; 
					if (textlines.size()>0){
						secondLine = textlines.get(0);
					}
					if (secondLine != null && secondLine.equals("<>")) {
						y = y + textheight();
						printCenter("<<" + uweStereotypeName + ">>", y);
						textlines.remove(0);
					}

					try {
						// UWE stereotype path
						java.awt.image.BufferedImage img =
								javax.imageio.ImageIO
										.read(new java.io.FileInputStream("UWEStereotypes/"
												+ (uweSubfolder.equals("") ? "" : uweSubfolder + "/") + uweStereotypeName
												+ ".png"));
						// show image in the upper right corner
						g2.drawImage(img, this.getWidth() - 20, 4, this);
						
					} catch (java.io.IOException e) {
						y = y + textheight();
						printLeft("Please copy the 'UWEStereotypes' folder in the directory:", y);
						y = y + textheight();
						printLeft(System.getProperty("user.dir"), y);
					} catch (SecurityException se){
						y = y + textheight();
                        printLeft("Your version of UMLet prohibits to load custom images.", y);
                    }
					
				}else{
					if (firstLine.length() != 0){
						g2.drawString("Unknown UWE type", 2, this.getHeight() / 2);
					}
				}
			}
		}
		
		// center all lines and print left after the first
		// separation line ("--")
		boolean printLeft = false;
		for (String textline : textlines) {
			if (textline.equals("--")) {
				y = y + 6;
				drawLineHorizontal(y);
				y = y + 2;
				printLeft = true;
			} else {
				y = y + textheight();
				if (printLeft) {
					printLeft(textline, y);
				} else {
					printCenter(textline, y);
				}
			}
		}
		/****CUSTOM_CODE END****/
	}
}
